function egwformcheck(f)
{
	var j = f.elements.length, i, re, args, result, str
	for (i=0; i<j; i++){
		if (typeof(f.elements[i].tag) == "undefined") continue;
		args = f.elements[i].tag.split("", 3);
		if ((args[0]=="1") || ((args[0]=="0") && (f.elements[i].value.length>0))){
			var str = f.elements[i].value;
			switch(args[1]){
				case "id": {var pattern = /^([0-9a-z]{4,12})+$/; if (!pattern.test(str)) result = false; break;}
				case "pwd": {var pattern = /^([0-9A-Za-z]{4,12})+$/; if (!pattern.test(str)) result = false; break;}
				case "post": {var pattern = /(\d{3}-\d{3})/; if (!pattern.test(str)) result = false; break;}
				case "tel": {var pattern = /^(\d{2,3}-\d{3,4}-\d{4})$/; if (!pattern.test(str)) result = false; break;}
				case "email": {var pattern = /(^((\w|[\-\.])+)@((\w|[\-\.])+)\.([a-za-z]+)$)/; if (!pattern.test(str)) result = false; break;}
				case "homepage": {var pattern = /([a-z0-9-]+\.[][a-za-z0-9\s{0,1}:&#@=_~%;\?\/\.\+-]+)/; if (!pattern.test(str)) result = false; break;}
				case "jumin": { result = fncjumin(str); break;}
				case "biznum": { result = fncbiznum(str); break; }
				case "date": { result = fncdate(str); break; }
				case "numeric": {var pattern = /^[0-9]+$/; if (!pattern.test(str)) result = false; break;}
				case "hangul": {var pattern = /^[-R]+$/; if (!pattern.test(str)) result = false; break;}
				case "alphabet": {var pattern = /^[A-Za-z]+$/; if (!pattern.test(str)) result = false; break;}
				case "alphanumeric": {var pattern = /^[A-Za-z0-9]+$/; if (!pattern.test(str)) result = false; break;}
				default :{
					if (args[0]== "1"){
						if ((f.elements[i].type == "textarea") && (f.elements[i].value != "")){
							break;
						}else	if (f.elements[i].type == "radio" || f.elements[i].type == "checkbox"){
							result = fncrc(f.elements[i].name);
							break;
						}else if (args[1] != ""){
							re = new RegExp("^" + args[1] + "$", "gi");
							str = toNormalize(f.elements[i].value);
							result = re.test(str);
						}else{
							var pattern = /.{1,}/; if (!pattern.test(str)) result = false; break;
						}
					}else if (args[1] != ""){
						re = new RegExp("^" + args[1] + "$", "gi");
						str = toNormalize(f.elements[i].value);
						result = re.test(str);
					}

				}
			}
		}
		if (result == false){
			alert(args[2]);
			f.elements[i].focus();
			return false;
		}
	}
	return true;
}

function toNormalize(str){
    var cvt = "";
    var len = str.length;
    var i, code;

    for(i=0; i<len; i++){
        if ((str.charCodeAt(i)<0)||(str.charCodeAt(i)>127)){
            cvt = cvt + "ko";
        }else{
            cvt = cvt + str.charAt(i);
        }
    }
    return cvt;
}


// /üũڽ ȿ üũ
function fncrc(str)
{
	var bnocheck = true;
	var flength = eval("document.frm."+str+".length")
	for(var i = 0; i < flength; i++){
		 if(eval("document.frm."+str+"[i].checked")) bnocheck = false;
	}
	if(bnocheck){
	   str = false;
	}else{
		str = true;
	}
	return str;
}

//ֹιȣ ȿ
function fncjumin(str)
{
	var pattern = /^([0-9]{6})-?([0-9]{7})$/;
	if (!pattern.test(str)){
		return num = false;
	}else{
		num = RegExp.$1 + RegExp.$2;
		var sum = 0;
		var last = num.charCodeAt(12) - 0x30;
		var bases = "234567892345";
		for (i=0; i<12; i++) {
			if (isNaN(num.substring(i,i+1))) num = false;
			sum += (num.charCodeAt(i) - 0x30) * (bases.charCodeAt(i) - 0x30);
		}
		var mod = sum % 11;
		return ((11 - mod) % 10 == last) ? num = true : num = false;
	}
}

//ڹȣ ȿ
function fncbiznum(str)
{
    var pattern = /([0-9]{3})-?([0-9]{2})-?([0-9]{5})/;
    if (!pattern.test(str)){
		return num = false;
	}else{
		num = RegExp.$1 + RegExp.$2 + RegExp.$3;
		var cVal = 0;
		for (var i=0; i<8; i++) {
			var cKeyNum = parseInt(((_tmp = i % 3) == 0) ? 1 : ( _tmp  == 1 ) ? 3 : 7);
			cVal += (parseFloat(num.substring(i,i+1)) * cKeyNum) % 10;
		}
		var li_temp = parseFloat(num.substring(i,i+1)) * 5 + '0';
		cVal += parseFloat(li_temp.substring(0,1)) + parseFloat(li_temp.substring(1,2));
		return (parseInt(num.substring(9,10)) == 10-(cVal % 10)%10) ? num=true : num=false;
	}
}

//¥üũ ȿ
function fncdate(str)
{
	var err=0
	var pattern = /(\d{4}-\d{2}-\d{2})/;
    if (!pattern.test(str)){
		err = 1;
	}else{
		var strTempArr = str.split('-');
		if ( strTempArr[0].length != 4) err=1
		if ( strTempArr[1].length != 1 &&  strTempArr[1].length !=  2 ) err=1
		if ( strTempArr[2].length != 1  &&  strTempArr[2].length !=  2) err=1

		r_year = eval(strTempArr[0]) ;
		r_month = eval(strTempArr[1]);
		r_day = eval(strTempArr[2])  ;

		if (r_month<1 || r_month>12) err = 1
		if (r_day<1 || r_day>31) err = 1
		if (r_year<0 ) err = 1

		if (r_month==4 || r_month==6 || r_month==9 || r_month==11){
			if (r_day==31) err=1
		}

		// üũ
		if (r_month==2){
			var g=parseInt(r_year/4)
			if (isNaN(g)) {
				err=1
			}
			if (r_day>29) err=1
			if (r_day==29 && ((r_year/4)!=parseInt(r_year/4))) err=1
		}
	}
	if (err==1){
		return false
	}else{
	    return true;
	}
}